#include <Foundation/Foundation.h>
#include <AppKit/AppKit.h>

@interface Foo : NSObject

@end

@implementation Foo
- (void) applicationWillFinishLaunching:(id)something
{
  NSWindow *win = [[NSWindow alloc] initWithContentRect:NSMakeRect(350,350,128,180)
					styleMask:NSTitledWindowMask
					 backing:NSBackingStoreBuffered
					defer:NO];

  NSPopUpButton *bevelButton = [[NSPopUpButton alloc] initWithFrame:NSMakeRect(0,0, 50, 50) pullsDown:YES];
  NSPopUpButton *button2 = [[NSPopUpButton alloc] initWithFrame:NSMakeRect(0.0,52.0, 107, 28) pullsDown:YES];
  NSPopUpButton *button3 = [[NSPopUpButton alloc] initWithFrame:NSMakeRect(0.0,82.0, 107, 28) pullsDown:NO];
  NSPopUpButton *button4 = [[NSPopUpButton alloc] initWithFrame:NSMakeRect(0.0, 110, 107, 28) pullsDown:YES];
  NSPopUpButton *iconButton = [[NSPopUpButton alloc] initWithFrame:NSMakeRect(55.0, 0.0, 50, 50) pullsDown:YES];
  NSArray *bevelStuff = [NSArray arrayWithObjects:@"bevel button", @"lets say", @"these are", @"wider than", @"the button", nil];
  NSArray *iconStuff = [NSArray arrayWithObjects:@"icon button", @"lets say", @"these are", @"wider than", @"the button", nil];
  NSArray *pulldownUsesMenu = [NSArray arrayWithObjects:@"default", @"pull-down", @"menu", @"with one wide item...........", nil];
  NSArray *popupStuff = [NSArray arrayWithObjects:@"default", @"pop-up", @"menu", @"with one wide item...........", nil];
  NSArray *pullDownStuff = [NSArray arrayWithObjects:@"usesItemFromMenu:NO", @"pull-down", @"menu", @"with one wide item...........", nil];
  unsigned int i, c;
  
  [[bevelButton cell] setArrowPosition:NSPopUpNoArrow];
  
  [bevelButton addItemsWithTitles:bevelStuff];
  [button2 addItemsWithTitles:pulldownUsesMenu];
  [button3 addItemsWithTitles:popupStuff];
  [button4 addItemsWithTitles:pullDownStuff];
  [iconButton addItemsWithTitles:iconStuff];
 
  [[bevelButton cell] setUsesItemFromMenu:NO];
  [bevelButton setBezelStyle:NSShadowlessSquareBezelStyle]; 
  [bevelButton setTitle:@"&"];
  [[bevelButton cell] setAltersStateOfSelectedItem:YES];
  [bevelButton setPreferredEdge:NSMinYEdge];
  NSLog(@"%i", [[bevelButton cell] arrowPosition] == NSPopUpNoArrow);

  [[button4 cell] setUsesItemFromMenu:NO];
  [button4 setTitle:@"%"];  

  [[iconButton cell] setUsesItemFromMenu:NO];
  [[iconButton cell] setBordered:NO];
  
  for (i = 0, c = [iconStuff count]; i < c; i++)
    {
      NSString *thing = [iconStuff objectAtIndex:i];
      NSMenuItem <NSMenuItem> *item = [bevelButton itemWithTitle:thing];    
      [item setOnStateImage:[NSImage imageNamed:@"common_2DCheckMark"]];
      [item setState:NSOnState];
    }  
  //[bevelButton sizeToFit]; 
  [[win contentView] addSubview:bevelButton]; 
  [[win contentView] addSubview:button2]; 
  [[win contentView] addSubview:button3]; 
  [[win contentView] addSubview:button4]; 
  [[win contentView] addSubview:iconButton]; 
  [win makeKeyAndOrderFront:self]; 
}

@end

int main()
{
  NSAutoreleasePool *pool = [NSAutoreleasePool new];
  NSApplication *nsapp = [NSApplication sharedApplication];
  NSMenu *main_menu = [NSMenu new];
  Foo *appDel = [Foo new];
  [main_menu addItemWithTitle:@"quit"
		 action:@selector(terminate:) keyEquivalent:@"q"];
  [NSApp setMainMenu: main_menu];

  [nsapp setDelegate:appDel]; 
    
  [nsapp run];
  RELEASE(pool);
  return 0;
}
